/* Copyright (c) 1992 Colin Jensen.  All Rights Reserved. */

/* bseord.h */

 /******************************************************************************\
 *                                                                             *
 * Module Name: BSEORD.H                                                       *
 *                                                                             *
 * OS/2 Base MEMory Flags include file                                         *
 *                                                                             *
 * Copyright (c) 1989  - 1992 IBM Corporation                                  *
 *                                                                             *
 *******************************************************************************/

#ifndef __BSEORD__
#define __BSEORD__

#ifdef __IBMC__
#pragma checkout( suspend )
   #ifndef __CHKHDR__
      #pragma checkout( suspend )
   #endif
#pragma checkout( resume )
#endif

/* ANSICALL */
#define ORD_ANSIINJECT 1
#define ORD_ANSIKEYDEF 2
#define ORD_ANSIINTERP 3
/* BDCALLS */
#define ORD_NLSCONVERTBIDINUMERICS  1
#define ORD_NLSCONVERTBIDISTRING    2
#define ORD_NLSSETBIDIATT           5
#define ORD_NLSQUERYBIDIATT         6
#define ORD_NLSINVERSESTRING        7
#define ORD_NLSSETBIDIPRINT         8
#define ORD_NLSEDITSHAPE            9
#define ORD_NLSSHAPEBIDISTRING      10/* 16:Nls%ShapeBidiString */
#define ORD_NLSINTSETBIDIATT        3
#define ORD_NLSINTQUERYBIDIATT      4
#define ORD_NLPOPUP                11
/* BKSCALLS */
#define ORD_BKSMAIN     1
/* BMSCALLS */
#define ORD_BKSMAIN     1
/* BVSCALLS */
#define ORD_BKSMAIN     1
/* PMDRAG */
#define ORD_DRGACCESSDRAGINFO                1
#define ORD_DRGADDSTRHANDLE                  2
#define ORD_DRGALLOCDRAGINFO                 3
#define ORD_DRGALLOCDRAGTRANSFER             4
#define ORD_DRGDELETEDRAGINFOSTRHANDLES      5
#define ORD_DRGDELETESTRHANDLE               6
#define ORD_DRGDRAG                          7
#define ORD_DRGFREEDRAGINFO                  8
#define ORD_DRGFREEDRAGTRANSFER              9
#define ORD_DRGGETPS                        10
#define ORD_DRGPOSTTRANSFERMSG              11
#define ORD_DRGPUSHDRAGINFO                 12
#define ORD_DRGQUERYDRAGITEM                13
#define ORD_DRGQUERYDRAGITEMCOUNT           14
#define ORD_DRGQUERYDRAGITEMPTR             15
#define ORD_DRGQUERYNATIVERMF               16
#define ORD_DRGQUERYNATIVERMFLEN            17
#define ORD_DRGQUERYSTRNAME                 18
#define ORD_DRGQUERYSTRNAMELEN              19
#define ORD_DRGQUERYTRUETYPE                20
#define ORD_DRGQUERYTRUETYPELEN             21
#define ORD_DRGRELEASEPS                    22
#define ORD_DRGSENDTRANSFERMSG              23
#define ORD_DRGSETDRAGPOINTER               24
#define ORD_DRGSETDRAGIMAGE                 25
#define ORD_DRGSETDRAGITEM                  26
#define ORD_DRGVERIFYNATIVERMF              27
#define ORD_DRGVERIFYRMF                    28
#define ORD_DRGVERIFYTRUETYPE               29
#define ORD_DRGVERIFYTYPE                   30
#define ORD_DRGVERIFYTYPESET                31
#define ORD_DRGDRAGFILES                    63
#define ORD_DRGACCEPTDROPPEDFILES           64
#define ORD_DRG32ACCESSDRAGINFO             32
#define ORD_DRG32ADDSTRHANDLE               33
#define ORD_DRG32ALLOCDRAGINFO              34
#define ORD_DRG32ALLOCDRAGTRANSFER          35
#define ORD_DRG32DELETEDRAGINFOSTRHANDLES   36
#define ORD_DRG32DELETESTRHANDLE            37
#define ORD_DRG32DRAG                       38
#define ORD_DRG32FREEDRAGINFO               39
#define ORD_DRG32FREEDRAGTRANSFER           40
#define ORD_DRG32GETPS                      41
#define ORD_DRG32POSTTRANSFERMSG            42
#define ORD_DRG32PUSHDRAGINFO               43
#define ORD_DRG32QUERYDRAGITEM              44
#define ORD_DRG32QUERYDRAGITEMCOUNT         45
#define ORD_DRG32QUERYDRAGITEMPTR           46
#define ORD_DRG32QUERYNATIVERMF             47
#define ORD_DRG32QUERYNATIVERMFLEN          48
#define ORD_DRG32QUERYSTRNAME               49
#define ORD_DRG32QUERYSTRNAMELEN            50
#define ORD_DRG32QUERYTRUETYPE              51
#define ORD_DRG32QUERYTRUETYPELEN           52
#define ORD_DRG32RELEASEPS                  53
#define ORD_DRG32SENDTRANSFERMSG            54
#define ORD_DRG32SETDRAGPOINTER             55
#define ORD_DRG32SETDRAGIMAGE               56
#define ORD_DRG32SETDRAGITEM                57
#define ORD_DRG32VERIFYNATIVERMF            58
#define ORD_DRG32VERIFYRMF                  59
#define ORD_DRG32VERIFYTRUETYPE             60
#define ORD_DRG32VERIFYTYPE                 61
#define ORD_DRG32VERIFYTYPESET              62
#define ORD_DRG32DRAGFILES                  65
#define ORD_DRG32ACCEPTDROPPEDFILES         66
/* FKA */
#define ORD_FKAINIT                 64
#define ORD_QUERYFKADISPLAYDETAILS  65
#define ORD_WINFKAWNDPROC           66
#define ORD_WINLOADFKA              67
#define ORD_WINCREATEFKA            68
#define ORD_WINSETFKAFORM           69
#define ORD_WINQUERYFKAFORM         70
#define ORD_WINGOTOFKA              71
#define ORD_WINGOFROMFKA            72
/* HELPMGR */
#define ORD_WINCREATEHELPINSTANCE        1
#define ORD_WINDESTROYHELPINSTANCE       2
#define ORD_WINQUERYHELPINSTANCE         3
#define ORD_WINASSOCIATEHELPINSTANCE     4
#define ORD_WINLOADHELPTABLE             5
#define ORD_WINCREATEHELPTABLE           6
#define ORD_WIN32CREATEHELPINSTANCE     51
#define ORD_WIN32DESTROYHELPINSTANCE    52
#define ORD_WIN32QUERYHELPINSTANCE      53
#define ORD_WIN32ASSOCIATEHELPINSTANCE  54
#define ORD_WIN32LOADHELPTABLE          55
#define ORD_WIN32CREATEHELPTABLE        56
#define ORD_DDFINITIALIZE               74
#define ORD_DDFPARA                     75
#define ORD_DDFSETFORMAT                76
#define ORD_DDFSETTEXTALIGN             77
#define ORD_DDFSETCOLOR                 78
#define ORD_DDFINFORM                   79
#define ORD_DDFSETFONTSTYLE             80
#define ORD_DDFHYPERTEXT                81
#define ORD_DDFBEGINLIST                82
#define ORD_DDFLISTITEM                 83
#define ORD_DDFENDLIST                  84
#define ORD_DDFTEXT                     85
#define ORD_DDFMETAFILE                 86
#define ORD_DDFSETFONT                  87
#define ORD_DDFBITMAP                   88
/* KBDCALLS */
#define ORD_KBDSETCUSTXT    1
#define ORD_KBDGETCP        3
#define ORD_KBDCHARIN       4
#define ORD_KBDSETCP        5
#define ORD_KBDSYNCH        7
#define ORD_KBDREGISTER     8
#define ORD_KBDSTRINGIN     9
#define ORD_KBDGETSTATUS    10
#define ORD_KBDSETSTATUS    11
#define ORD_KBDGETFOCUS     12
#define ORD_KBDFLUSHBUFFER  13
#define ORD_KBDXLATE        14
#define ORD_KBDCLOSE        17
#define ORD_KBDFREEFOCUS    18
#define ORD_KBDDEREGISTER   20
#define ORD_KBDSETFGND      21
#define ORD_KBDPEEK         22
#define ORD_KBDOPEN         23
#define ORD_KBDGETHWID      24
#define ORD_KBDSETHWID      25
/* MONCALLS */
#define ORD_DOSMONOPEN  4
#define ORD_DOSMONCLOSE 3
#define ORD_DOSMONREAD  2
#define ORD_DOSMONWRITE 1
#define ORD_DOSMONREG   5
/* MOUCALLS */
#define ORD_MOUGETPTRSHAPE   1
#define ORD_MOUSETPTRSHAPE   2
#define ORD_MOUGETNUMMICKEYS 3
#define ORD_MOUGETHOTKEY     4
#define ORD_MOUGETSCALEFACT  6
#define ORD_MOUFLUSHQUE      7
#define ORD_MOUGETNUMBUTTONS 8
#define ORD_MOUCLOSE         9
#define ORD_MOUSETHOTKEY     10
#define ORD_MOUSETSCALEFACT  11
#define ORD_MOUGETNUMQUEEL   13
#define ORD_MOUDEREGISTER    14
#define ORD_MOUGETEVENTMASK  15
#define ORD_MOUSETEVENTMASK  16
#define ORD_MOUOPEN          17
#define ORD_MOUREMOVEPTR     18
#define ORD_MOUGETPTRPOS     19
#define ORD_MOUREADEVENTQUE  20
#define ORD_MOUSETPTRPOS     21
#define ORD_MOUGETDEVSTATUS  22
#define ORD_MOUSYNCH         23
#define ORD_MOUREGISTER      24
#define ORD_MOUSETDEVSTATUS  25
#define ORD_MOUDRAWPTR       26
#define ORD_MOUINITREAL      27
#define ORD_MOUGETTHRESHOLD  29
#define ORD_MOUSETTHRESHOLD  30
/* MSG */
#define ORD_DOSPUTMESSAGE        1
#define ORD_DOSTRUEGETMESSAGE    2
#define ORD_DOSINSMESSAGE        3
#define ORD_DOS32INSERTMESSAGE   4
#define ORD_DOS32PUTMESSAGE      5
#define ORD_DOS32TRUEGETMESSAGE  6
#define ORD_DOSIQUERYMESSAGECP   7
#define ORD_DOS32IQUERYMESSAGECP 8
/* NLS */
#define ORD_DOSCASEMAP          1
#define ORD_DOSGETCOLLATE       2
#define ORD_DOSGETCTRYINFO      3
#define ORD_DOSGETDBCSEV        4
#define ORD_DOS32QUERYCTRYINFO  5
#define ORD_DOS32QUERYDBCSENV   6
#define ORD_DOS32MAPCASE        7
#define ORD_DOS32QUERYCOLLATE   8
/* NAMPIPES */
#define ORD_DOSMAKENMPIPE       1
#define ORD_DOSQNMPIPEINFO      2
#define ORD_DOSCONNECTNMPIPE    3
#define ORD_DOSDISCONNECTNMPIPE 4
#define ORD_DOSQNMPHANDSTATE    5
#define ORD_DOSSETNMPHANDSTATE  6
#define ORD_DOSPEEKNMPIPE       7
#define ORD_DOSWAITNMPIPE       8
#define ORD_DOSTRANSACTNMPIPE   9
#define ORD_DOSCALLNMPIPE      10
#define ORD_DOSRAWREADNMPIPE   11
#define ORD_DOSRAWWRITENMPIPE  12
#define ORD_DOSSETNMPIPESEM    13
#define ORD_DOSQNMPIPESEMSTATE 14
/* DOSCALLS */
#define ORD_DOSCWAIT                    2
#define ORD_DOSENTERCRITSEC             3
#define ORD_DOSEXIT                     5
#define ORD_DOSEXITCRITSEC              6
#define ORD_DOSEXITLIST                 7
#define ORD_DOSGETINFOSEG               8
#define ORD_DOSGETPRTY                  9
#define ORD_DOSKILLPROCESS              10
#define ORD_DOSSETPRTY                  11
#define ORD_DOSPTRACE                   12
#define ORD_DOSHOLDSIGNAL               13
#define ORD_DOSSETSIGHANDLER            14
#define ORD_DOSFLAGPROCESS              15
#define ORD_DOSMAKEPIPE                 16
#define ORD_DOSSEMSETWAIT               20
#define ORD_DOSMUXSEMWAIT               22
#define ORD_DOSCLOSESEM                 23
#define ORD_DOSCREATESEM                24
#define ORD_DOSOPENSEM                  25
#define ORD_DOSRESUMETHREAD             26
#define ORD_DOSSUSPENDTHREAD            27
#define ORD_DOSSETDATETIME              28
#define ORD_DOSTIMERASYNC               29
#define ORD_DOSTIMERSTART               30
#define ORD_DOSTIMERSTOP                31
#define ORD_DOSSLEEP                    32
#define ORD_DOSGETDATETIME              33
#define ORD_DOSALLOCSEG                 34
#define ORD_DOSALLOCSHRSEG              35
#define ORD_DOSGETSHRSEG                36
#define ORD_DOSGIVESEG                  37
#define ORD_DOSREALLOCSEG               38
#define ORD_DOSFREESEG                  39
#define ORD_DOSALLOCHUGE                40
#define ORD_DOSGETHUGESHIFT             41
#define ORD_DOSREALLOCHUGE              42
#define ORD_DOSCREATECSALIAS            43
#define ORD_DOSLOADMODULE               44
#define ORD_DOSGETPROCADDR              45
#define ORD_DOSFREEMODULE               46
#define ORD_DOSGETMODHANDLE             47
#define ORD_DOSGETMODNAME               48
#define ORD_DOSGETMACHINEMODE           49
#define ORD_DOSBEEP                     50
#define ORD_DOSCLIACCESS                51
#define ORD_DOSDEVCONFIG                52
#define ORD_DOSDEVIOCTL                 53
#define ORD_DOSBUFRESET                 56
#define ORD_DOSCHDIR                    57
#define ORD_DOSCHGFILEPTR               58
#define ORD_DOSCLOSE                    59
#define ORD_DOSDELETE                   60
#define ORD_DOSDUPHANDLE                61
#define ORD_DOSFILELOCKS                62
#define ORD_DOSFINDCLOSE                63
#define ORD_DOSFINDFIRST                64
#define ORD_DOSFINDNEXT                 65
#define ORD_DOSMKDIR                    66
#define ORD_DOSMOVE                     67
#define ORD_DOSNEWSIZE                  68
#define ORD_DOSPORTACCESS               69
#define ORD_DOSOPEN                     70
#define ORD_DOSQCURDIR                  71
#define ORD_DOSQCURDISK                 72
#define ORD_DOSQFHANDSTATE              73
#define ORD_DOSQFILEINFO                74
#define ORD_DOSQFILEMODE                75
#define ORD_DOSQFSINFO                  76
#define ORD_DOSQHANDTYPE                77
#define ORD_DOSQVERIFY                  78
#define ORD_DOSRMDIR                    80
#define ORD_DOSSELECTDISK               81
#define ORD_DOSSETFHANDSTATE            82
#define ORD_DOSSETFILEINFO              83
#define ORD_DOSSETFILEMODE              84
#define ORD_DOSSETMAXFH                 85
#define ORD_DOSSETVERIFY                86
#define ORD_DOSSYSTEMSERVICE            88
#define ORD_DOSSETVEC                   89
#define ORD_DOSSYSTRACE                 90
#define ORD_DOSGETENV                   91
#define ORD_DOSGETVERSION               92
#define ORD_DOSGETPID                   94
#define ORD_DOSOPEN2                    95
#define ORD_DOSLIBINIT                  96
#define ORD_DOSSETFSINFO                97
#define ORD_DOSQPATHINFO                98
#define ORD_DOSDEVIOCTL2                99
#define ORD_DOSSETPATHINFO              104
#define ORD_DOSISETRELMAXFH             108
#define ORD_DOSIDEVIOCTL                109
#define ORD_DOS32FORCEDELETE            110
#define ORD_DOS32KILLTHREAD             111
#define ORD_DOSQUERYRASINFO             112
#define ORD_DOSERROR                    120
#define ORD_DOSGETSEG                   121
#define ORD_DOSLOCKSEG                  122
#define ORD_DOSUNLOCKSEG                123
#define ORD_DOSSIZESEG                  126
#define ORD_DOSMEMAVAIL                 127
#define ORD_DOSPHYSICALDISK             129
#define ORD_DOSGETCP                    130
#define ORD_DOSSENDSIGNAL               134
#define ORD_DOSHUGESHIFT                135
#define ORD_DOSHUGEINCR                 136
#define ORD_DOSREAD                     137
#define ORD_DOSWRITE                    138
#define ORD_DOSERRCLASS                 139
#define ORD_DOSSEMREQUEST               140
#define ORD_DOSSEMCLEAR                 141
#define ORD_DOSSEMWAIT                  142
#define ORD_DOSSEMSET                   143
#define ORD_DOSEXECPGM                  144
#define ORD_DOSCREATETHREAD             145
#define ORD_DOSSUBSET                   146
#define ORD_DOSSUBALLOC                 147
#define ORD_DOSSUBFREE                  148
#define ORD_DOSREADASYNC                149
#define ORD_DOSWRITEASYNC               150
#define ORD_DOSSEARCHPATH               151
#define ORD_DOSSCANENV                  152
#define ORD_DOSSETCP                    153
#define ORD_DOSGETRESOURCE              155
#define ORD_DOSGETPPID                  156
#define ORD_DOSCALLBACK                 157
#define ORD_DOSR2STACKREALLOC           160
#define ORD_DOSFSRAMSEMREQUEST          161
#define ORD_DOSFSRAMSEMCLEAR            162
#define ORD_DOSQAPPTYPE                 163
#define ORD_DOSSETPROCCP                164
#define ORD_DOSDYNAMICTRACE             165
#define ORD_DOSQSYSINFO                 166
#define ORD_DOSFSATTACH                 181
#define ORD_DOSQFSATTACH                182
#define ORD_DOSFSCTL                    183
#define ORD_DOSFINDFIRST2               184
#define ORD_DOSMKDIR2                   185
#define ORD_DOSFILEIO                   186
#define ORD_DOSFINDNOTIFYCLOSE          187
#define ORD_DOSFINDNOTIFYFIRST          188
#define ORD_DOSFINDNOTIFYNEXT           189
#define ORD_DOSEDITNAME                 191
#define ORD_DOSCOPY                     201
#define ORD_DOSFORCEDELETE              203
#define ORD_DOSENUMATTRIBUTE            204
#define ORD_DOSSHUTDOWN                 206
#define ORD_DOSGETRESOURCE2             207
#define ORD_DOSFREERESOURCE             208
#define ORD_DOS32SETMAXFH               209
#define ORD_DOS32SETVERIFY              210
#define ORD_DOS32ERRCLASS               211
#define ORD_DOS32ERROR                  212
#define ORD_DOSMAXPATHLEN               214
#define ORD_DOSPAGESIZE                 215
#define ORD_DOSLOCALINFO                216
#define ORD_DOSGLOBALINFO               217
#define ORD_DOS32SETFILEINFO            218
#define ORD_DOS32SETPATHINFO            219
#define ORD_DOS32SETDEFAULTDISK         220
#define ORD_DOS32SETFHSTATE             221
#define ORD_DOS32SETFSINFO              222
#define ORD_DOS32QUERYPATHINFO          223
#define ORD_DOS32QUERYHTYPE             224
#define ORD_DOS32QUERYVERIFY            225
#define ORD_DOS32DELETEDIR              226
#define ORD_DOS32SCANENV                227
#define ORD_DOS32SEARCHPATH             228
#define ORD_DOS32SLEEP                  229
#define ORD_DOS32GETDATETIME            230
#define ORD_DOS32DEVCONFIG              231
#define ORD_DOS32ENTERCRITSEC           232
#define ORD_DOS32EXITCRITSEC            233
#define ORD_DOS32EXIT                   234
#define ORD_DOS32KILLPROCESS            235
#define ORD_DOS32SETPRIORITY            236
#define ORD_DOS32RESUMETHREAD           237
#define ORD_DOS32SUSPENDTHREAD          238
#define ORD_DOS32CREATEPIPE             239
#define ORD_DOS32CALLNPIPE              240
#define ORD_DOS32CONNECTNPIPE           241
#define ORD_DOS32DISCONNECTNPIPE        242
#define ORD_DOS32CREATENPIPE            243
#define ORD_DOS32PEEKNPIPE              244
#define ORD_DOS32QUERYNPHSTATE          245
#define ORD_DOS32RAWREADNPIPE           246
#define ORD_DOS32RAWWRITENPIPE          247
#define ORD_DOS32QUERYNPIPEINFO         248
#define ORD_DOS32QUERYNPIPESEMSTATE     249
#define ORD_DOS32SETNPHSTATE            250
#define ORD_DOS32SETNPIPESEM            251
#define ORD_DOS32TRANSACTNPIPE          252
#define ORD_DOS32WAITNPIPE              253
#define ORD_DOS32RESETBUFFER            254
#define ORD_DOS32SETCURRENTDIR          255
#define ORD_DOS32SETFILEPTR             256
#define ORD_DOS32CLOSE                  257
#define ORD_DOS32COPY                   258
#define ORD_DOS32DELETE                 259
#define ORD_DOS32DUPHANDLE              260
#define ORD_DOS32EDITNAME               261
#define ORD_DOS32FINDCLOSE              263
#define ORD_DOS32FINDFIRST              264
#define ORD_DOS32FINDNEXT               265
#define ORD_DOSOPENVDD                  266
#define ORD_DOSREQUESTVDD               267
#define ORD_DOSCLOSEVDD                 268
#define ORD_DOS32FSATTACH               269
#define ORD_DOS32CREATEDIR              270
#define ORD_DOS32MOVE                   271
#define ORD_DOS32SETFILESIZE            272
#define ORD_DOS32OPEN                   273
#define ORD_DOS32QUERYCURRENTDIR        274
#define ORD_DOS32QUERYCURRENTDISK       275
#define ORD_DOS32QUERYFHSTATE           276
#define ORD_DOS32QUERYFSATTACH          277
#define ORD_DOS32QUERYFSINFO            278
#define ORD_DOS32QUERYFILEINFO          279
#define ORD_DOS32WAITCHILD              280
#define ORD_DOS32READ                   281
#define ORD_DOS32WRITE                  282
#define ORD_DOS32EXECPGM                283
#define ORD_DOS32DEVIOCTL               284
#define ORD_DOS32FSCTL                  285
#define ORD_DOS32BEEP                   286
#define ORD_DOS32PHYSICALDISK           287
#define ORD_DOS32SETCP                  288
#define ORD_DOS32SETPROCESSCP           289
#define ORD_DOS32STOPTIMER              290
#define ORD_DOS32QUERYCP                291
#define ORD_DOS32SETDATETIME            292
#define ORD_DOS32EXITLIST               296
#define ORD_DOS32ALLOCMEM               299
#define ORD_DOS32ALLOCSHAREDMEM         300
#define ORD_DOS32GETNAMEDSHAREDMEM      301
#define ORD_DOS32GETSHAREDMEM           302
#define ORD_DOS32GIVESHAREDMEM          303
#define ORD_DOS32FREEMEM                304
#define ORD_DOS32SETMEM                 305
#define ORD_DOS32QUERYMEM               306
#define ORD_DOS32OPENVDD                308
#define ORD_DOS32REQUESTVDD             309
#define ORD_DOS32CLOSEVDD               310
#define ORD_DOS32CREATETHREAD           311
#define ORD_DOS32GETINFOBLOCKS          312
#define ORD_DOS32DYNAMICTRACE           316
#define ORD_DOS32DEBUG                  317
#define ORD_DOS32LOADMODULE             318
#define ORD_DOS32QUERYMODULEHANDLE      319
#define ORD_DOS32QUERYMODULENAME        320
#define ORD_DOS32QUERYPROCADDR          321
#define ORD_DOS32FREEMODULE             322
#define ORD_DOS32QUERYAPPTYPE           323
#define ORD_DOS32CREATEEVENTSEM         324
#define ORD_DOS32OPENEVENTSEM           325
#define ORD_DOS32CLOSEEVENTSEM          326
#define ORD_DOS32RESETEVENTSEM          327
#define ORD_DOS32POSTEVENTSEM           328
#define ORD_DOS32WAITEVENTSEM           329
#define ORD_DOS32QUERYEVENTSEM          330
#define ORD_DOS32CREATEMUTEXSEM         331
#define ORD_DOS32OPENMUTEXSEM           332
#define ORD_DOS32CLOSEMUTEXSEM          333
#define ORD_DOS32REQUESTMUTEXSEM        334
#define ORD_DOS32RELEASEMUTEXSEM        335
#define ORD_DOS32QUERYMUTEXSEM          336
#define ORD_DOS32CREATEMUXWAITSEM       337
#define ORD_DOS32OPENMUXWAITSEM         338
#define ORD_DOS32CLOSEMUXWAITSEM        339
#define ORD_DOS32WAITMUXWAITSEM         340
#define ORD_DOS32ADDMUXWAITSEM          341
#define ORD_DOS32DELETEMUXWAITSEM       342
#define ORD_DOS32QUERYMUXWAITSEM        343
#define ORD_DOS32SUBSETMEM              344
#define ORD_DOS32SUBALLOCMEM            345
#define ORD_DOS32SUBFREEMEM             346
#define ORD_DOS32SUBUNSETMEM            347
#define ORD_DOS32QUERYSYSINFO           348
#define ORD_DOS32WAITTHREAD             349
#define ORD_DOS32ASYNCTIMER             350
#define ORD_DOS32STARTTIMER             351
#define ORD_DOS32GETRESOURCE            352
#define ORD_DOS32FREERESOURCE           353
#define ORD_DOS32SETEXCEPTIONHANDLER    354
#define ORD_DOS32UNSETEXCEPTIONHANDLER  355
#define ORD_DOS32RAISEEXCEPTION         356
#define ORD_DOS32UNWINDEXCEPTION        357
#define ORD_DOS32TMRQUERYFREQ           362
#define ORD_DOS32TMRQUERYTIME           363
#define ORD_DOS32REGISTERPERFCTRS       367
#define ORD_DOS32ENUMATTRIBUTE          372
#define ORD_DOS32QUERYDOSPROPERTY       373
#define ORD_DOS32SETDOSPROPERTY         374
#define ORD_DOSQUERYDOSPROPERTY         375
#define ORD_DOSSETDOSPROPERTY           376
#define ORD_DOS32PROFILE                377
#define ORD_DOS32SETSIGNALEXCEPTIONFOC  378
#define ORD_DOS32SENDSIGNALEXCEPTION    379
#define ORD_DOS32ENTERMUSTCOMPLETE      380
#define ORD_DOS32EXITMUSTCOMPLETE       381
#define ORD_DOS32SETRELMAXFH            382
#define ORD_DOS32SHUTDOWN               415
#define ORD_DOS32REPLACEMODULE          417
#define ORD_DOS32ACKNOWLEDGESIGNALEXC   418
#define ORD_DOS32TIB                    419
#define ORD_DOSTMRQUERYFREQ             420
#define ORD_DOSTMRQUERYTIME             421
#define ORD_DOSREGISTERPERFCTRS         422
#define ORD_DOSFLATTOSEL                423
#define ORD_DOSSELTOFLAT                424
#define ORD_DOS32FLATTOSEL              425
#define ORD_DOS32SELTOFLAT              426
#define ORD_DOS32SETFILELOCKS             428
#define ORD_DOS32CANCELLOCKREQUEST        429
#define ORD_DOSOPENCHANGENOTIFY         437
#define ORD_DOSRESETCHANGENOTIFY        438
#define ORD_DOSCLOSECHANGENOTIFY        439
#define ORD_DOS32OPENCHANGENOTIFY       440
#define ORD_DOS32RESETCHANGENOTIFY      441
#define ORD_DOS32CLOSECHANGENOTIFY      442
#define ORD_DOS32QUERYRESOURCESIZE      572
#define ORD_DOSQUERYRESOURCESIZE        573
#define ORD_DOS32INITIALIZEPORTHOLE     580
#define ORD_DOS32QUERYHEADERINFO        582
#define ORD_DOSINITIALIZEPORTHOLE       583
#define ORD_DOSQUERYHEADERINFO          584
#define ORD_DOS32QUERYPROCTYPE          586
#define ORD_DOSQUERYPROCTYPE            587
/* PMGPI */
#define ORD_DEVOPENDC                      1
#define ORD_DEVCLOSEDC                     2
#define ORD_DEVPOSTDEVICEMODES             3
#define ORD_DEVESCAPE                      4
#define ORD_DEVQUERYHARDCOPYCAPS           5
#define ORD_DEVQUERYCAPS                   6
#define ORD_GPICREATEPS                    7
#define ORD_GPIQUERYPS                     9
#define ORD_GPIDESTROYPS                   10
#define ORD_GPIRESETPS                     11
#define ORD_GPISAVEPS                      12
#define ORD_GPIRESTOREPS                   13
#define ORD_GPIASSOCIATE                   14
#define ORD_GPIERRORSEGMENTDATA            15
#define ORD_GPIERASE                       16
#define ORD_GPISETDRAWCONTROL              17
#define ORD_GPIQUERYDRAWCONTROL            18
#define ORD_GPIDRAWCHAIN                   19
#define ORD_GPIDRAWFROM                    20
#define ORD_GPIDRAWSEGMENT                 21
#define ORD_GPISETSTOPDRAW                 22
#define ORD_GPIQUERYSTOPDRAW               23
#define ORD_GPIREMOVEDYNAMICS              24
#define ORD_GPIDRAWDYNAMICS                25
#define ORD_GPISETDRAWINGMODE              26
#define ORD_GPIQUERYDRAWINGMODE            27
#define ORD_GPIGETDATA                     28
#define ORD_GPIPUTDATA                     29
#define ORD_GPISETPICKAPERTURESIZE         30
#define ORD_GPIQUERYPICKAPERTURESIZE       31
#define ORD_GPISETPICKAPERTUREPOSITION     32
#define ORD_GPIQUERYPICKAPERTUREPOSITION   33
#define ORD_GPISETTAG                      34
#define ORD_GPIQUERYTAG                    35
#define ORD_GPICORRELATECHAIN              36
#define ORD_GPICORRELATEFROM               37
#define ORD_GPICORRELATESEGMENT            38
#define ORD_GPIRESETBOUNDARYDATA           42
#define ORD_GPIQUERYBOUNDARYDATA           43
#define ORD_GPIOPENSEGMENT                 44
#define ORD_GPICLOSESEGMENT                46
#define ORD_GPIDELETESEGMENT               47
#define ORD_GPIDELETESEGMENTS              48
#define ORD_GPIQUERYSEGMENTNAMES           49
#define ORD_GPISETINITIALSEGMENTATTRS      51
#define ORD_GPIQUERYINITIALSEGMENTATTRS    52
#define ORD_GPISETSEGMENTATTRS             53
#define ORD_GPIQUERYSEGMENTATTRS           54
#define ORD_GPISETSEGMENTPRIORITY          55
#define ORD_GPIQUERYSEGMENTPRIORITY        56
#define ORD_GPISETEDITMODE                 57
#define ORD_GPIQUERYEDITMODE               58
#define ORD_GPISETELEMENTPOINTER           59
#define ORD_GPIQUERYELEMENTPOINTER         60
#define ORD_GPIOFFSETELEMENTPOINTER        61
#define ORD_GPIDELETEELEMENT               62
#define ORD_GPIDELETEELEMENTRANGE          63
#define ORD_GPILABEL                       64
#define ORD_GPISETELEMENTPOINTERATLABEL    65
#define ORD_GPIDELETEELEMENTSBETWEENLABELS 66
#define ORD_GPIQUERYELEMENTTYPE            67
#define ORD_GPIQUERYELEMENT                68
#define ORD_GPIELEMENT                     69
#define ORD_GPIBEGINELEMENT                70
#define ORD_GPIENDELEMENT                  71
#define ORD_GPISETSEGMENTTRANSFORMMATRIX   78
#define ORD_GPIQUERYSEGMENTTRANSFORMMATRIX 79
#define ORD_GPISETMODELTRANSFORMMATRIX     80
#define ORD_GPIQUERYMODELTRANSFORMMATRIX   81
#define ORD_GPICALLSEGMENTMATRIX           82
#define ORD_GPISETDEFAULTVIEWMATRIX        83
#define ORD_GPIQUERYDEFAULTVIEWMATRIX      84
#define ORD_GPISETPAGEVIEWPORT             85
#define ORD_GPIQUERYPAGEVIEWPORT           86
#define ORD_GPISETVIEWINGTRANSFORMMATRIX   87
#define ORD_GPIQUERYVIEWINGTRANSFORMMATRIX 88
#define ORD_GPISETGRAPHICSFIELD            89
#define ORD_GPIQUERYGRAPHICSFIELD          90
#define ORD_GPISETVIEWINGLIMITS            91
#define ORD_GPIQUERYVIEWINGLIMITS          92
#define ORD_GPICONVERT                     93
#define ORD_GPISETATTRMODE                 94
#define ORD_GPIQUERYATTRMODE               95
#define ORD_GPIPOP                         96
#define ORD_GPISETATTRS                    97
#define ORD_GPIQUERYATTRS                  98
#define ORD_GPICREATELOGCOLORTABLE         99
#define ORD_GPIREALIZECOLORTABLE           100
#define ORD_GPIUNREALIZECOLORTABLE         101
#define ORD_GPIQUERYCOLORDATA              102
#define ORD_GPIQUERYLOGCOLORTABLE          103
#define ORD_GPIQUERYREALCOLORS             104
#define ORD_GPIQUERYNEARESTCOLOR           105
#define ORD_GPIQUERYCOLORINDEX             106
#define ORD_GPIQUERYRGBCOLOR               107
#define ORD_GPISETCOLOR                    108
#define ORD_GPIQUERYCOLOR                  109
#define ORD_GPISETBACKCOLOR                110
#define ORD_GPIQUERYBACKCOLOR              111
#define ORD_GPISETMIX                      112
#define ORD_GPIQUERYMIX                    113
#define ORD_GPISETBACKMIX                  114
#define ORD_GPIQUERYBACKMIX                115
#define ORD_GPISETLINETYPE                 116
#define ORD_GPIQUERYLINETYPE               117
#define ORD_GPISETLINEWIDTH                118
#define ORD_GPIQUERYLINEWIDTH              119
#define ORD_GPISETLINEWIDTHGEOM            120
#define ORD_GPIQUERYLINEWIDTHGEOM          121
#define ORD_GPISETLINEEND                  122
#define ORD_GPIQUERYLINEEND                123
#define ORD_GPISETLINEJOIN                 124
#define ORD_GPIQUERYLINEJOIN               125
#define ORD_GPISETCURRENTPOSITION          126
#define ORD_GPIQUERYCURRENTPOSITION        127
#define ORD_GPIMOVE                        128
#define ORD_GPILINE                        129
#define ORD_GPIPOLYLINE                    130
#define ORD_GPIBOX                         131
#define ORD_GPIPTVISIBLE                   132
#define ORD_GPIRECTVISIBLE                 133
#define ORD_GPISETARCPARAMS                134
#define ORD_GPIQUERYARCPARAMS              135
#define ORD_GPIPOINTARC                    136
#define ORD_GPIFULLARC                     137
#define ORD_GPIPARTIALARC                  138
#define ORD_GPIPOLYFILLET                  139
#define ORD_GPIPOLYFILLETSHARP             140
#define ORD_GPIPOLYSPLINE                  141
#define ORD_GPISETBITMAPID                 142
#define ORD_GPIQUERYBITMAPHANDLE           143
#define ORD_GPISETPATTERNSET               144
#define ORD_GPIQUERYPATTERNSET             145
#define ORD_GPISETPATTERN                  146
#define ORD_GPIQUERYPATTERN                147
#define ORD_GPISETPATTERNREFPOINT          148
#define ORD_GPIQUERYPATTERNREFPOINT        149
#define ORD_GPIBEGINAREA                   150
#define ORD_GPIENDAREA                     151
#define ORD_GPILOADFONTS                   152
#define ORD_GPIUNLOADFONTS                 153
#define ORD_GPICREATELOGFONT               154
#define ORD_GPIDELETESETID                 155
#define ORD_GPIQUERYNUMBERSETIDS           156
#define ORD_GPIQUERYSETIDS                 157
#define ORD_GPIQUERYFONTS                  158
#define ORD_GPIQUERYFONTMETRICS            159
#define ORD_GPIQUERYKERNINGPAIRS           160
#define ORD_GPIQUERYWIDTHTABLE             161
#define ORD_GPISETCP                       162
#define ORD_GPIQUERYCP                     163
#define ORD_GPIQUERYTEXTBOX                164
#define ORD_DEVQUERYDEVICENAMES            165
#define ORD_GPIQUERYDEFCHARBOX             166
#define ORD_GPIQUERYFONTFILEDESCRIPTIONS   167
#define ORD_GPISETCHARSET                  168
#define ORD_GPIQUERYCHARSET                169
#define ORD_GPISETCHARBOX                  170
#define ORD_GPIQUERYCHARBOX                171
#define ORD_GPISETCHARANGLE                172
#define ORD_GPIQUERYCHARANGLE              173
#define ORD_GPISETCHARSHEAR                174
#define ORD_GPIQUERYCHARSHEAR              175
#define ORD_GPISETCHARDIRECTION            176
#define ORD_GPIQUERYCHARDIRECTION          177
#define ORD_GPISETCHARMODE                 178
#define ORD_GPIQUERYCHARMODE               179
#define ORD_GPICHARSTRING                  180
#define ORD_GPICHARSTRINGAT                181
#define ORD_GPICHARSTRINGPOS               182
#define ORD_GPICHARSTRINGPOSAT             183
#define ORD_GPISETMARKERSET                184
#define ORD_GPIQUERYMARKERSET              185
#define ORD_GPISETMARKER                   186
#define ORD_GPIQUERYMARKER                 187
#define ORD_GPISETMARKERBOX                188
#define ORD_GPIQUERYMARKERBOX              189
#define ORD_GPIMARKER                      190
#define ORD_GPIPOLYMARKER                  191
#define ORD_GPIIMAGE                       192
#define ORD_GPICREATEBITMAP                196
#define ORD_GPIDELETEBITMAP                197
#define ORD_GPISETBITMAP                   198
#define ORD_GPISETBITMAPDIMENSION          199
#define ORD_GPIQUERYBITMAPDIMENSION        200
#define ORD_GPIQUERYDEVICEBITMAPFORMATS    201
#define ORD_GPIQUERYBITMAPPARAMETERS       202
#define ORD_GPISETBITMAPBITS               203
#define ORD_GPIQUERYBITMAPBITS             204
#define ORD_GPIBITBLT                      205
#define ORD_GPISETPEL                      206
#define ORD_GPIQUERYPEL                    207
#define ORD_GPICREATEREGION                208
#define ORD_GPISETREGION                   209
#define ORD_GPIDESTROYREGION               210
#define ORD_GPICOMBINEREGION               211
#define ORD_GPIEQUALREGION                 212
#define ORD_GPIOFFSETREGION                213
#define ORD_GPIPTINREGION                  214
#define ORD_GPIRECTINREGION                215
#define ORD_GPIQUERYREGIONBOX              216
#define ORD_GPIQUERYREGIONRECTS            217
#define ORD_GPISETCLIPREGION               218
#define ORD_GPIQUERYCLIPREGION             219
#define ORD_GPIQUERYCLIPBOX                220
#define ORD_GPIINTERSECTCLIPRECTANGLE      221
#define ORD_GPIEXCLUDECLIPRECTANGLE        222
#define ORD_GPIOFFSETCLIPREGION            223
#define ORD_GPIPAINTREGION                 224
#define ORD_GPILOADMETAFILE                225
#define ORD_GPICOPYMETAFILE                226
#define ORD_GPIPLAYMETAFILE                227
#define ORD_GPISAVEMETAFILE                228
#define ORD_GPIDELETEMETAFILE              229
#define ORD_GPIQUERYMETAFILEBITS           230
#define ORD_GPISETMETAFILEBITS             231
#define ORD_GPIQUERYMETAFILELENGTH         232
#define ORD_GPISETCLIPPATH                 233
#define ORD_GPIBEGINPATH                   234
#define ORD_GPIENDPATH                     235
#define ORD_GPICLOSEFIGURE                 236
#define ORD_GPIMODIFYPATH                  237
#define ORD_GPIFILLPATH                    238
#define ORD_GPISTARTREQUEST                239
#define ORD_GPIQUERYDEVICE                 240
#define ORD_DEVSTDOPEN                     244
#define ORD_GPIQUERYCHARSTRINGPOS          245
#define ORD_GPIQUERYCHARSTRINGPOSAT        246
#define ORD_GPISETPS                       248
#define ORD_SEGSGWOPENSEGMENTWINDOW        249
#define ORD_MTENDREADREQUEST               250
#define ORD_MTGETDESCRIPTION               251
#define ORD_FMTORDERTABLE                  252
#define ORD_MTGETCODEPAGE                  253
#define ORD_MTGETLCT                       254
#define ORD_MTGETGDDINFO                   255
#define ORD_FMTCONVERTGOCAPOLY             256
#define ORD_MTGETFIRSTFONT                 257
#define ORD_SEGSGWNEWPARTDATA              258
#define ORD_MTSTARTREADREQUEST             259
#define ORD_MTGETFIRSTGRAPHICSDATA         260
#define ORD_MTGETNEXTFONT                  261
#define ORD_MTGETNEXTGRAPHICSDATA          262
#define ORD_GPILOADPUBLICFONTS             263
#define ORD_GPIUNLOADPUBLICFONTS           264
#define ORD_GPICOMMENT                     268
#define ORD_GPIWCBITBLT                    269
#define ORD_GPISTROKEPATH                  270
#define ORD_SEGSGWNEXTORDERF               271
#define ORD_GPIOUTLINEPATH                 274
#define ORD_GPISETDEFTAG                   275
#define ORD_GPIQUERYDEFTAG                 276
#define ORD_GPISETDEFATTRS                 277
#define ORD_GPIQUERYDEFATTRS               278
#define ORD_GPISETDEFVIEWINGLIMITS         279
#define ORD_GPIQUERYDEFVIEWINGLIMITS       280
#define ORD_GPISETDEFARCPARAMS             281
#define ORD_GPIQUERYDEFARCPARAMS           282
#define ORD_GPITRANSLATE                   283
#define ORD_GPISCALE                       284
#define ORD_GPIROTATE                      285
#define ORD_GPIPOLYLINEDISJOINT            286
#define ORD_GPIPATHTOREGION                287
#define ORD_GPIFLOODFILL                   289
#define ORD_GPIDRAWBITS                    290
#define ORD_GPIQUERYBITMAPINFOHEADER       291
#define ORD_GPIQUERYLOGICALFONT            292
#define ORD_GPIQUERYFACESTRING             293
#define ORD_GPIQUERYFONTACTION             294
#define ORD_GPICREATEPALETTE               295
#define ORD_GPIDELETEPALETTE               296
#define ORD_GPISELECTPALETTE               297
#define ORD_GPIANIMATEPALETTE              298
#define ORD_GPISETPALETTEENTRIES           299
#define ORD_GPIQUERYPALETTE                300
#define ORD_GPIQUERYPALETTEINFO            301
#define ORD_GPIQUERYCHAREXTRA              302
#define ORD_GPISETCHAREXTRA                303
#define ORD_GPIQUERYCHARBREAKEXTRA         304
#define ORD_GPISETCHARBREAKEXTRA           305
#define ORD_GPIFRAMEREGION                 306
#define ORD_GPICONVERTWITHMATRIX           307
#define ORD_GPI32ASSOCIATE                 351
#define ORD_GPI32BEGINAREA                 352
#define ORD_GPI32BEGINELEMENT              353
#define ORD_GPI32BEGINPATH                 354
#define ORD_GPI32BITBLT                    355
#define ORD_GPI32BOX                       356
#define ORD_GPI32CALLSEGMENTMATRIX         357
#define ORD_GPI32CHARSTRING                358
#define ORD_GPI32CHARSTRINGAT              359
#define ORD_GPI32CLOSEFIGURE               360
#define ORD_GPI32CLOSESEGMENT              361
#define ORD_GPI32COMBINEREGION             362
#define ORD_GPI32COMMENT                   363
#define ORD_GPI32CONVERT                   364
#define ORD_GPI32COPYMETAFILE              365
#define ORD_GPI32CORRELATECHAIN            366
#define ORD_GPI32CORRELATEFROM             367
#define ORD_GPI32CREATELOGFONT             368
#define ORD_GPI32CREATEPS                  369
#define ORD_GPI32CREATEREGION              370
#define ORD_GPI32DELETEBITMAP              371
#define ORD_GPI32DELETEELEMENT             372
#define ORD_GPI32DELETEELEMENTRANGE        373
#define ORD_GPI32DELETEELEMENTSBETWEENLABE 374
#define ORD_GPI32DELETEMETAFILE            375
#define ORD_GPI32DELETESEGMENT             376
#define ORD_GPI32DELETESEGMENTS            377
#define ORD_GPI32DELETESETID               378
#define ORD_GPI32DESTROYPS                 379
#define ORD_GPI32DRAWCHAIN                 380
#define ORD_GPI32DRAWDYNAMICS              381
#define ORD_GPI32DRAWFROM                  382
#define ORD_GPI32DRAWSEGMENT               383
#define ORD_GPI32ELEMENT                   384
#define ORD_GPI32ENDAREA                   385
#define ORD_GPI32ENDELEMENT                386
#define ORD_GPI32ENDPATH                   387
#define ORD_GPI32EQUALREGION               388
#define ORD_GPI32ERASE                     389
#define ORD_GPI32ERRORSEGMENTDATA          390
#define ORD_GPI32EXCLUDECLIPRECTANGLE      391
#define ORD_GPI32FILLPATH                  392
#define ORD_GPI32FULLARC                   393
#define ORD_GPI32GETDATA                   394
#define ORD_GPI32IMAGE                     395
#define ORD_GPI32INTERSECTCLIPRECTANGLE    396
#define ORD_GPI32LABEL                     397
#define ORD_GPI32LINE                      398
#define ORD_GPI32LOADBITMAP                399
#define ORD_GPI32LOADFONTS                 400
#define ORD_GPI32LOADMETAFILE              401
#define ORD_GPI32MARKER                    402
#define ORD_GPI32MODIFYPATH                403
#define ORD_GPI32MOVE                      404
#define ORD_GPI32OFFSETCLIPREGION          405
#define ORD_GPI32OFFSETELEMENTPOINTER      406
#define ORD_GPI32OFFSETREGION              407
#define ORD_GPI32OPENSEGMENT               408
#define ORD_GPI32PAINTREGION               409
#define ORD_GPI32PLAYMETAFILE              411
#define ORD_GPI32POINTARC                  412
#define ORD_GPI32POLYFILLET                413
#define ORD_GPI32POLYFILLETSHARP           414
#define ORD_GPI32POLYLINE                  415
#define ORD_GPI32POLYMARKER                416
#define ORD_GPI32POLYSPLINE                417
#define ORD_GPI32POP                       418
#define ORD_GPI32PTINREGION                419
#define ORD_GPI32PTVISIBLE                 420
#define ORD_GPI32PUTDATA                   421
#define ORD_GPI32QUERYARCPARAMS            422
#define ORD_GPI32QUERYATTRMODE             423
#define ORD_GPI32QUERYBACKCOLOR            424
#define ORD_GPI32QUERYBACKMIX              425
#define ORD_GPI32QUERYBITMAPDIMENSION      426
#define ORD_GPI32QUERYBITMAPHANDLE         427
#define ORD_GPI32QUERYBOUNDARYDATA         428
#define ORD_GPI32QUERYCHARANGLE            429
#define ORD_GPI32QUERYCHARBOX              430
#define ORD_GPI32QUERYCHARDIRECTION        431
#define ORD_GPI32QUERYCHARMODE             432
#define ORD_GPI32QUERYCHARSET              433
#define ORD_GPI32QUERYCHARSHEAR            434
#define ORD_GPI32QUERYCLIPBOX              435
#define ORD_GPI32QUERYCLIPREGION           436
#define ORD_GPI32QUERYCOLOR                437
#define ORD_GPI32QUERYCOLORDATA            438
#define ORD_GPI32QUERYCOLORINDEX           439
#define ORD_GPI32QUERYCP                   440
#define ORD_GPI32QUERYCURRENTPOSITION      441
#define ORD_GPI32QUERYDEFCHARBOX           442
#define ORD_GPI32QUERYDEFAULTVIEWMATRIX    443
#define ORD_GPI32QUERYDEVICE               444
#define ORD_GPI32QUERYDEVICEBITMAPFORMATS  445
#define ORD_GPI32QUERYDRAWCONTROL          446
#define ORD_GPI32QUERYDRAWINGMODE          447
#define ORD_GPI32QUERYEDITMODE             448
#define ORD_GPI32QUERYELEMENT              449
#define ORD_GPI32QUERYELEMENTPOINTER       450
#define ORD_GPI32QUERYELEMENTTYPE          451
#define ORD_GPI32QUERYFONTFILEDESCRIPTIONS 452
#define ORD_GPI32QUERYFONTMETRICS          453
#define ORD_GPI32QUERYGRAPHICSFIELD        454
#define ORD_GPI32QUERYINITIALSEGMENTATTRS  455
#define ORD_GPI32QUERYKERNINGPAIRS         456
#define ORD_GPI32QUERYLINEEND              457
#define ORD_GPI32QUERYLINEJOIN             458
#define ORD_GPI32QUERYLINETYPE             459
#define ORD_GPI32QUERYLINEWIDTH            460
#define ORD_GPI32QUERYLINEWIDTHGEOM        461
#define ORD_GPI32QUERYMARKER               462
#define ORD_GPI32QUERYMARKERBOX            463
#define ORD_GPI32QUERYMARKERSET            464
#define ORD_GPI32QUERYMETAFILEBITS         465
#define ORD_GPI32QUERYMETAFILELENGTH       466
#define ORD_GPI32QUERYMIX                  467
#define ORD_GPI32QUERYMODELTRANSFORMMATRIX 468
#define ORD_GPI32QUERYNEARESTCOLOR         469
#define ORD_GPI32QUERYNUMBERSETIDS         470
#define ORD_GPI32QUERYPS                   471
#define ORD_GPI32QUERYPAGEVIEWPORT         472
#define ORD_GPI32QUERYPATTERN              473
#define ORD_GPI32QUERYPATTERNREFPOINT      474
#define ORD_GPI32QUERYPATTERNSET           475
#define ORD_GPI32QUERYPEL                  476
#define ORD_GPI32QUERYPICKAPERTUREPOSITION 477
#define ORD_GPI32QUERYPICKAPERTURESIZE     478
#define ORD_GPI32QUERYRGBCOLOR             479
#define ORD_GPI32QUERYREALCOLORS           480
#define ORD_GPI32QUERYREGIONBOX            481
#define ORD_GPI32QUERYSEGMENTATTRS         482
#define ORD_GPI32QUERYSEGMENTNAMES         483
#define ORD_GPI32QUERYSEGMENTPRIORITY      484
#define ORD_GPI32QUERYSEGMENTTRANSFORMMATR 485
#define ORD_GPI32QUERYSETIDS               486
#define ORD_GPI32QUERYSTOPDRAW             487
#define ORD_GPI32QUERYTAG                  488
#define ORD_GPI32QUERYTEXTBOX              489
#define ORD_GPI32QUERYVIEWINGLIMITS        490
#define ORD_GPI32QUERYVIEWINGTRANSFORMMATR 491
#define ORD_GPI32QUERYWIDTHTABLE           492
#define ORD_GPI32RECTINREGION              494
#define ORD_GPI32RECTVISIBLE               495
#define ORD_GPI32REMOVEDYNAMICS            496
#define ORD_GPI32RESETBOUNDARYDATA         497
#define ORD_GPI32RESETPS                   498
#define ORD_GPI32RESTOREPS                 499
#define ORD_GPI32SAVEMETAFILE              500
#define ORD_GPI32SAVEPS                    501
#define ORD_GPI32SETARCPARAMS              502
#define ORD_GPI32SETATTRMODE               503
#define ORD_GPI32SETBACKCOLOR              504
#define ORD_GPI32SETBACKMIX                505
#define ORD_GPI32SETBITMAP                 506
#define ORD_GPI32SETBITMAPDIMENSION        507
#define ORD_GPI32SETBITMAPID               508
#define ORD_GPI32SETCHARANGLE              509
#define ORD_GPI32SETCHARBOX                510
#define ORD_GPI32SETCHARDIRECTION          511
#define ORD_GPI32SETCHARMODE               512
#define ORD_GPI32SETCHARSET                513
#define ORD_GPI32SETCHARSHEAR              514
#define ORD_GPI32SETCLIPPATH               515
#define ORD_GPI32SETCLIPREGION             516
#define ORD_GPI32SETCOLOR                  517
#define ORD_GPI32SETCP                     518
#define ORD_GPI32SETCURRENTPOSITION        519
#define ORD_GPI32SETDEFAULTVIEWMATRIX      520
#define ORD_GPI32SETDRAWCONTROL            521
#define ORD_GPI32SETDRAWINGMODE            522
#define ORD_GPI32SETEDITMODE               523
#define ORD_GPI32SETELEMENTPOINTER         524
#define ORD_GPI32SETELEMENTPOINTERATLABEL  525
#define ORD_GPI32SETGRAPHICSFIELD          526
#define ORD_GPI32SETINITIALSEGMENTATTRS    527
#define ORD_GPI32SETLINEEND                528
#define ORD_GPI32SETLINEJOIN               529
#define ORD_GPI32SETLINETYPE               530
#define ORD_GPI32SETLINEWIDTH              531
#define ORD_GPI32SETLINEWIDTHGEOM          532
#define ORD_GPI32SETMARKER                 533
#define ORD_GPI32SETMARKERBOX              534
#define ORD_GPI32SETMARKERSET              535
#define ORD_GPI32SETMETAFILEBITS           536
#define ORD_GPI32SETMIX                    537
#define ORD_GPI32SETMODELTRANSFORMMATRIX   538
#define ORD_GPI32SETPS                     539
#define ORD_GPI32SETPAGEVIEWPORT           540
#define ORD_GPI32SETPATTERN                541
#define ORD_GPI32SETPATTERNREFPOINT        542
#define ORD_GPI32SETPATTERNSET             543
#define ORD_GPI32SETPEL                    544
#define ORD_GPI32SETPICKAPERTUREPOSITION   545
#define ORD_GPI32SETREGION                 546
#define ORD_GPI32SETSEGMENTATTRS           547
#define ORD_GPI32SETSEGMENTPRIORITY        548
#define ORD_GPI32SETSEGMENTTRANSFORMMATRIX 549
#define ORD_GPI32SETSTOPDRAW               550
#define ORD_GPI32SETTAG                    551
#define ORD_GPI32SETVIEWINGLIMITS          552
#define ORD_GPI32SETVIEWINGTRANSFORMMATRIX 553
#define ORD_GPI32STROKEPATH                554
#define ORD_GPI32UNLOADFONTS               555
#define ORD_GPI32WCBITBLT                  557
#define ORD_GPI32POLYLINEDISJOINT          558
#define ORD_GPI32PATHTOREGION              559
#define ORD_GPI32FLOODFILL                 560
#define ORD_GPI32SUSPENDPLAY               561
#define ORD_GPI32RESUMEPLAY                562
#define ORD_GPI32OUTLINEPATH               563
#define ORD_GPI32TRANSLATE                 564
#define ORD_GPI32SCALE                     565
#define ORD_GPI32ROTATE                    566
#define ORD_GPI32QUERYDEFARCPARAMS         567
#define ORD_GPI32QUERYDEFTAG               568
#define ORD_GPI32QUERYDEFVIEWINGLIMITS     569
#define ORD_GPI32SETDEFARCPARAMS           570
#define ORD_GPI32SETDEFTAG                 571
#define ORD_GPI32SETDEFVIEWINGLIMITS       572
#define ORD_GPI32QUERYBITMAPPARAMETERS     573
#define ORD_GPI32QUERYLOGICALFONT          574
#define ORD_GPI32QUERYFACESTRING           575
#define ORD_GPI32QUERYFONTACTION           576
#define ORD_GPI32DELETEPALETTE             577
#define ORD_GPI32SELECTPALETTE             578
#define ORD_GPI32QUERYPALETTE              579
#define ORD_GPI32CHARSTRINGPOS             580
#define ORD_GPI32CHARSTRINGPOSAT           581
#define ORD_GPI32CORRELATESEGMENT          582
#define ORD_GPI32QUERYATTRS                583
#define ORD_GPI32QUERYCHARSTRINGPOS        584
#define ORD_GPI32QUERYCHARSTRINGPOSAT      585
#define ORD_GPI32QUERYFONTS                586
#define ORD_GPI32QUERYREGIONRECTS          587
#define ORD_GPI32SETATTRS                  588
#define ORD_GPI32SETPICKAPERTURESIZE       589
#define ORD_GPI32QUERYDEFATTRS             590
#define ORD_GPI32SETDEFATTRS               591
#define ORD_GPI32CREATELOGCOLORTABLE       592
#define ORD_GPI32QUERYLOGCOLORTABLE        593
#define ORD_GPI32CREATEPALETTE             594
#define ORD_GPI32ANIMATEPALETTE            595
#define ORD_GPI32SETPALETTEENTRIES         596
#define ORD_GPI32QUERYPALETTEINFO          597
#define ORD_GPI32CREATEBITMAP              598
#define ORD_GPI32QUERYBITMAPBITS           599
#define ORD_GPI32QUERYBITMAPINFOHEADER     601
#define ORD_GPI32SETBITMAPBITS             602
#define ORD_GPI32DRAWBITS                  603
#define ORD_DEV32CLOSEDC                   604
#define ORD_DEV32ESCAPE                    605
#define ORD_DEV32QUERYCAPS                 606
#define ORD_DEV32QUERYDEVICENAMES          607
#define ORD_DEV32QUERYHARDCOPYCAPS         608
#define ORD_DEV32POSTDEVICEMODES           609
#define ORD_DEV32OPENDC                    610
#define ORD_GPI32DESTROYREGION             611
#define ORD_GPI32PARTIALARC                612
#define ORD_GPI32QUERYCHAREXTRA            613
#define ORD_GPI32SETCHAREXTRA              614
#define ORD_GPI32QUERYCHARBREAKEXTRA       615
#define ORD_GPI32SETCHARBREAKEXTRA         616
#define ORD_GPI32FRAMEREGION               617
#define ORD_GPI32CONVERTWITHMATRIX         618
#define ORD_GPI32LOADPUBLICFONTS           622
#define ORD_GPI32UNLOADPUBLICFONTS         623
/* PMWIN */
#define ORD_WINQUERYDESKTOPWINDOW        1
#define ORD_WINQUERYOBJECTWINDOW         2
#define ORD_WINREGISTERCLASS             3
#define ORD_WINQUERYCLASSNAME            4
#define ORD_WINQUERYCLASSINFO            5
#define ORD_WINCREATEWINDOW              6
#define ORD_WINDESTROYWINDOW             7
#define ORD_WINSETWINDOWPOS              8
#define ORD_WINSETMULTWINDOWPOS          9
#define ORD_WINQUERYWINDOWPOS            10
#define ORD_WINENABLEWINDOW              11
#define ORD_WINISWINDOWENABLED           12
#define ORD_WINSHOWWINDOW                13
#define ORD_WINENABLEWINDOWUPDATE        14
#define ORD_WINISWINDOWVISIBLE           15
#define ORD_WINSETWINDOWTEXT             16
#define ORD_WINQUERYWINDOWTEXT           17
#define ORD_WINQUERYWINDOWTEXTLENGTH     18
#define ORD_WINWINDOWFROMID              19
#define ORD_WINMULTWINDOWFROMIDS         20
#define ORD_WINISWINDOW                  21
#define ORD_WINISCHILD                   22
#define ORD_WINSETPARENT                 23
#define ORD_WINSETOWNER                  24
#define ORD_WINQUERYWINDOW               25
#define ORD_WINQUERYWINDOWRECT           26
#define ORD_WINQUERYWINDOWPROCESS        27
#define ORD_WINSETWINDOWUSHORT           28
#define ORD_WINQUERYWINDOWUSHORT         29
#define ORD_WINSETWINDOWULONG            30
#define ORD_WINQUERYWINDOWULONG          31
#define ORD_WINBEGINENUMWINDOWS          32
#define ORD_WINGETNEXTWINDOW             33
#define ORD_WINENDENUMWINDOWS            34
#define ORD_WINWINDOWFROMPOINT           35
#define ORD_WINMAPWINDOWPOINTS           36
#define ORD_WINSUBCLASSWINDOW            37
#define ORD_WINLOCKWINDOW                38
#define ORD_WINQUERYWINDOWLOCKCOUNT      39
#define ORD_WINREGISTERWINDOWDESTROY     40
#define ORD_WINOPENWINDOWDC              41
#define ORD_WINGETSCREENPS               42
#define ORD_WINGETPS                     43
#define ORD_WINRELEASEPS                 44
#define ORD_WINBEGINPAINT                45
#define ORD_WINENDPAINT                  46
#define ORD_WININVALIDATERECT            47
#define ORD_WININVALIDATEREGION          48
#define ORD_WINVALIDATERECT              49
#define ORD_WINVALIDATEREGION            50
#define ORD_WINQUERYUPDATERECT           51
#define ORD_WINQUERYUPDATEREGION         52
#define ORD_WINUPDATEWINDOW              53
#define ORD_WINEXCLUDEUPDATEREGION       54
#define ORD_WINLOCKWINDOWUPDATE          55
#define ORD_WINLOCKVISREGIONS            56
#define ORD_WINWINDOWFROMDC              57
#define ORD_WINCREATEMSGQUEUE            58
#define ORD_WINDESTROYMSGQUEUE           59
#define ORD_WINQUERYQUEUESTATUS          60
#define ORD_WINSENDMSG                   61
#define ORD_WINBROADCASTMSG              63
#define ORD_WININSENDMSG                 64
#define ORD_WINGETMSG                    65
#define ORD_WINPEEKMSG                   66
#define ORD_WINWAITMSG                   67
#define ORD_WINDISPATCHMSG               68
#define ORD_WINPOSTMSG                   69
#define ORD_WINPOSTQUEUEMSG              70
#define ORD_WINQUERYMSGPOS               71
#define ORD_WINQUERYMSGTIME              72
#define ORD_WINCALLMSGFILTER             73
#define ORD_WINSETMSGINTEREST            74
#define ORD_WINSETCAPTURE                75
#define ORD_WINQUERYCAPTURE              76
#define ORD_WINSETFOCUS                  77
#define ORD_WINQUERYFOCUS                78
#define ORD_WINSETACTIVEWINDOW           79
#define ORD_WINQUERYACTIVEWINDOW         80
#define ORD_WINSETSYSMODALWINDOW         81
#define ORD_WINQUERYSYSMODALWINDOW       82
#define ORD_WINISTHREADACTIVE            83
#define ORD_WINSTARTTIMER                84
#define ORD_WINSTOPTIMER                 85
#define ORD_WINGETCURRENTTIME            86
#define ORD_WINLOADPOINTER               87
#define ORD_WINCREATEPOINTER             88
#define ORD_WINDESTROYPOINTER            89
#define ORD_OLDWINQUERYPOINTERINFO       90
#define ORD_WINQUERYSYSPOINTER           91
#define ORD_WINSETPOINTER                92
#define ORD_WINQUERYPOINTER              93
#define ORD_WINSHOWPOINTER               94
#define ORD_WINSETPOINTERPOS             95
#define ORD_WINQUERYPOINTERPOS           96
#define ORD_WINGETSYSBITMAP              97
#define ORD_WINCREATECURSOR              98
#define ORD_WINDESTROYCURSOR             99
#define ORD_WINSHOWCURSOR                100
#define ORD_WINQUERYCURSORINFO           101
#define ORD_WINLOADACCELTABLE            102
#define ORD_WINCREATEACCELTABLE          103
#define ORD_WINDESTROYACCELTABLE         104
#define ORD_WINTRANSLATEACCEL            105
#define ORD_WINSETACCELTABLE             106
#define ORD_WINQUERYACCELTABLE           107
#define ORD_WINCOPYACCELTABLE            108
#define ORD_WINSETHOOK                   109
#define ORD_WINRELEASEHOOK               110
#define ORD_WINOPENCLIPBRD               111
#define ORD_WINCLOSECLIPBRD              112
#define ORD_WINEMPTYCLIPBRD              113
#define ORD_WINSETCLIPBRDOWNER           114
#define ORD_WINQUERYCLIPBRDOWNER         115
#define ORD_WINSETCLIPBRDDATA            116
#define ORD_WINQUERYCLIPBRDDATA          117
#define ORD_WINENUMCLIPBRDFMTS           118
#define ORD_WINQUERYCLIPBRDFMTINFO       119
#define ORD_WINSETCLIPBRDVIEWER          120
#define ORD_WINQUERYCLIPBRDVIEWER        121
#define ORD_WINLOADDLG                   122
#define ORD_WINCREATEDLG                 123
#define ORD_WINPROCESSDLG                124
#define ORD_WINDLGBOX                    125
#define ORD_WINDISMISSDLG                126
#define ORD_WINSENDDLGITEMMSG            127
#define ORD_WINSETDLGITEMSHORT           128
#define ORD_WINQUERYDLGITEMSHORT         129
#define ORD_WINMAPDLGPOINTS              130
#define ORD_WINSUBSTITUTESTRINGS         132
#define ORD_WINENUMDLGITEM               133
#define ORD_WINSETDLGITEMTEXT            134
#define ORD_WINQUERYDLGITEMTEXT          135
#define ORD_WINLOADMENU                  136
#define ORD_WINCREATEMENU                137
#define ORD_WINALARM                     138
#define ORD_WINMESSAGEBOX                139
#define ORD_WINCREATESTDWINDOW           140
#define ORD_WINCREATEFRAMECONTROLS       141
#define ORD_WINCALCFRAMERECT             143
#define ORD_WINFLASHWINDOW               144
#define ORD_WINGETMINPOSITION            146
#define ORD_WINGETMAXPOSITION            147
#define ORD_WINQUERYSYSVALUE             149
#define ORD_WINSETSYSVALUE               150
#define ORD_WINSETSYSCOLORS              151
#define ORD_WINQUERYSYSCOLOR             152
#define ORD_WINSCROLLWINDOW              153
#define ORD_WINTRACKRECT                 154
#define ORD_WINSHOWTRACKRECT             155
#define ORD_GPILOADBITMAP                156
#define ORD_WINLOADSTRING                157
#define ORD_WINLOADMESSAGE               158
#define ORD_WINSETRECTEMPTY              159
#define ORD_WINSETRECT                   160
#define ORD_WINCOPYRECT                  161
#define ORD_WINISRECTEMPTY               162
#define ORD_WINEQUALRECT                 163
#define ORD_WINPTINRECT                  164
#define ORD_WINOFFSETRECT                165
#define ORD_WININFLATERECT               166
#define ORD_WININTERSECTRECT             167
#define ORD_WINUNIONRECT                 168
#define ORD_WINSUBTRACTRECT              169
#define ORD_WINMAKERECT                  170
#define ORD_WINMAKEPOINTS                171
#define ORD_WININVERTRECT                172
#define ORD_WINFILLRECT                  173
#define ORD_KBDPACKET                    174
#define ORD_WINDRAWPOINTER               177
#define ORD_WINDEFWINDOWPROC             178
#define ORD_WINDEFDLGPROC                179
#define ORD_WINGETKEYSTATE               211
#define ORD_WINGETPHYSKEYSTATE           212
#define ORD_WINSETKEYBOARDSTATETABLE     213
#define ORD_WINENABLEPHYSINPUT           214
#define ORD_WINSETCP                     215
#define ORD_WINQUERYCP                   216
#define ORD_WINQUERYCPLIST               217
#define ORD_WINCPTRANSLATESTRING         218
#define ORD_WINCPTRANSLATECHAR           219
#define ORD_WINCOMPARESTRINGS            220
#define ORD_WINUPPER                     221
#define ORD_WINUPPERCHAR                 222
#define ORD_WINNEXTCHAR                  223
#define ORD_WINPREVCHAR                  224
#define ORD_WINCREATEHEAP                225
#define ORD_WINDESTROYHEAP               226
#define ORD_WINAVAILMEM                  227
#define ORD_WINALLOCMEM                  228
#define ORD_WINREALLOCMEM                229
#define ORD_WINFREEMEM                   230
#define ORD_WINLOCKHEAP                  231
#define ORD_WINCREATEATOMTABLE           233
#define ORD_WINDESTROYATOMTABLE          234
#define ORD_WINADDATOM                   235
#define ORD_WINFINDATOM                  236
#define ORD_WINDELETEATOM                237
#define ORD_WINQUERYATOMUSAGE            238
#define ORD_WINQUERYATOMLENGTH           239
#define ORD_WINQUERYATOMNAME             240
#define ORD_WINQUERYSYSTEMATOMTABLE      241
#define ORD_WINGETLASTERROR              243
#define ORD_WINGETERRORINFO              244
#define ORD_WINFREEERRORINFO             245
#define ORD_WININITIALIZE                246
#define ORD_WINTERMINATE                 247
#define ORD_WINCATCH                     248
#define ORD_WINTHROW                     249
#define ORD_WINQUERYVERSION              250
#define ORD__WINSETERRORINFO             263
#define ORD_WINISPHYSINPUTENABLED        264
#define ORD_WINQUERYWINDOWDC             265
#define ORD_WINDRAWBORDER                266
#define ORD_WINDRAWTEXT                  267
#define ORD_WINDRAWBITMAP                268
#define ORD_WINQUERYWINDOWPTR            269
#define ORD_WINSETWINDOWPTR              270
#define ORD_WINMSGSEMWAIT                274
#define ORD_WINMSGMUXSEMWAIT             275
#define ORD_WINCANCELSHUTDOWN            277
#define ORD_WINSETWINDOWBITS             278
#define ORD_WINGETCLIPPS                 279
#define ORD_WINSAVEWINDOWPOS             285
#define ORD_WINFOCUSCHANGE               286
#define ORD_WINQUERYQUEUEINFO            287
#define ORD_WINSETCLASSMSGINTEREST       292
#define ORD_WINQUERYDLGITEMTEXTLENGTH    294
#define ORD_WINDDEINITIATE               297
#define ORD_WINDDERESPOND                298
#define ORD_WINDDEPOSTMSG                299
#define ORD_WINSETPRESPARAM              301
#define ORD_WINQUERYPRESPARAM            302
#define ORD_WINREMOVEPRESPARAM           303
#define  ORD_DUMWINCREATEHELPINSTANCE    311
#define  ORD_DUMWINDESTROYHELPINSTANCE   312
#define  ORD_DUMWINASSOCIATEHELPINSTANCE 313
#define  ORD_DUMWINCREATEHELPTABLE       314
#define  ORD_DUMWINLOADHELPTABLE         315
#define  ORD_DUMWINQUERYHELPINSTANCE     316
#define  ORD_DUMMYHELPENTRY              322
#define  ORD_WINSETCLASSTHUNKPROC        959
#define  ORD_WINQUERYCLASSTHUNKPROC      960
#define  ORD_WINSETWINDOWTHUNKPROC       961
#define  ORD_WINQUERYWINDOWTHUNKPROC     962
#define ORD_WINQUERYWINDOWMODEL          317
#define ORD_WINSETDESKTOPBKGND           318
#define ORD_WINQUERYDESKTOPBKGND         319
#define ORD_WINPOPUPMENU                 320
#define ORD_WINREALIZEPALETTE            321
#define ORD_WINDELETELIBRARY             602
#define ORD_WINLOADPROCEDURE             603
#define ORD_WINDELETEPROCEDURE           604
#define ORD_WINSETMSGMODE                605
#define ORD_WINSETSYNCHROMODE            606
#define ORD_WINGETDLGMSG                 607
#define ORD_WINREGISTERUSERMSG           608
#define ORD_WINQUERYANCHORBLOCK          609
#define ORD_WINREGISTERUSERDATATYPE      612
#define ORD_WINISWINDOWSHOWING           614
#define ORD_WINLOADLIBRARY               615
#define ORD_WINCREATEPOINTERINDIRECT     616
#define ORD_WINQUERYPOINTERINFO          617
#define ORD_WINGETERASEPS                624
#define ORD_WINRELEASEERASEPS            625
#define ORD_WINSTRETCHPOINTER            632
#define ORD_WINSETPOINTEROWNER           633
#define ORD_WIN32ADDATOM                 700
#define ORD_WIN32ALARM                   701
#define ORD_WIN32BEGINENUMWINDOWS        702
#define ORD_WIN32BEGINPAINT              703
#define ORD_WIN32CALCFRAMERECT           704
#define ORD_WIN32CANCELSHUTDOWN          705
#define ORD_WIN32CLOSECLIPBRD            707
#define ORD_WIN32COMPARESTRINGS          708
#define ORD_WIN32COPYACCELTABLE          709
#define ORD_WIN32COPYRECT                710
#define ORD_WIN32CPTRANSLATECHAR         711
#define ORD_WIN32CPTRANSLATESTRING       712
#define ORD_WIN32CREATEACCELTABLE        713
#define ORD_WIN32CREATEATOMTABLE         714
#define ORD_WIN32CREATECURSOR            715
#define ORD_WIN32CREATEMSGQUEUE          716
#define ORD_WIN32CREATEPOINTER           717
#define ORD_WIN32DDEINITIATE             718
#define ORD_WIN32DDEPOSTMSG              719
#define ORD_WIN32DDERESPOND              720
#define ORD_WIN32DELETEATOM              721
#define ORD_WIN32DELETELIBRARY           722
#define ORD_WIN32DESTROYACCELTABLE       723
#define ORD_WIN32DESTROYATOMTABLE        724
#define ORD_WIN32DESTROYCURSOR           725
#define ORD_WIN32DESTROYMSGQUEUE         726
#define ORD_WIN32DESTROYPOINTER          727
#define ORD_WIN32DESTROYWINDOW           728
#define ORD_WIN32DISMISSDLG              729
#define ORD_WIN32DRAWBITMAP              730
#define ORD_WIN32DRAWBORDER              731
#define ORD_WIN32DRAWPOINTER             732
#define ORD_WIN32EMPTYCLIPBRD            733
#define ORD_WIN32ENABLEPHYSINPUT         734
#define ORD_WIN32ENABLEWINDOW            735
#define ORD_WIN32ENABLEWINDOWUPDATE      736
#define ORD_WIN32ENDENUMWINDOWS          737
#define ORD_WIN32ENDPAINT                738
#define ORD_WIN32ENUMCLIPBRDFMTS         739
#define ORD_WIN32ENUMDLGITEM             740
#define ORD_WIN32EQUALRECT               741
#define ORD_WIN32EXCLUDEUPDATEREGION     742
#define ORD_WIN32FILLRECT                743
#define ORD_WIN32FINDATOM                744
#define ORD_WIN32FLASHWINDOW             745
#define ORD_WIN32FOCUSCHANGE             746
#define ORD_WIN32FREEERRORINFO           748
#define ORD_WIN32GETCLIPPS               749
#define ORD_WIN32GETCURRENTTIME          750
#define ORD_WIN32GETERRORINFO            751
#define ORD_WIN32GETKEYSTATE             752
#define ORD_WIN32GETLASTERROR            753
#define ORD_WIN32GETMAXPOSITION          754
#define ORD_WIN32GETMINPOSITION          755
#define ORD_WIN32GETNEXTWINDOW           756
#define ORD_WIN32GETPS                   757
#define ORD_WIN32GETPHYSKEYSTATE         758
#define ORD_WIN32GETSCREENPS             759
#define ORD_WIN32GETSYSBITMAP            760
#define ORD_WIN32INSENDMSG               761
#define ORD_WIN32INFLATERECT             762
#define ORD_WIN32INITIALIZE              763
#define ORD_WIN32INTERSECTRECT           764
#define ORD_WIN32INVALIDATERECT          765
#define ORD_WIN32INVALIDATEREGION        766
#define ORD_WIN32INVERTRECT              767
#define ORD_WIN32ISCHILD                 768
#define ORD_WIN32ISPHYSINPUTENABLED      769
#define ORD_WIN32ISRECTEMPTY             770
#define ORD_WIN32ISTHREADACTIVE          771
#define ORD_WIN32ISWINDOW                772
#define ORD_WIN32ISWINDOWENABLED         773
#define ORD_WIN32ISWINDOWSHOWING         774
#define ORD_WIN32ISWINDOWVISIBLE         775
#define ORD_WIN32LOADACCELTABLE          776
#define ORD_WIN32LOADLIBRARY             777
#define ORD_WIN32LOADMENU                778
#define ORD_WIN32LOADMESSAGE             779
#define ORD_WIN32LOADPOINTER             780
#define ORD_WIN32LOADSTRING              781
#define ORD_WIN32LOCKVISREGIONS          782
#define ORD_WIN32LOCKWINDOWUPDATE        784
#define ORD_WIN32MAKEPOINTS              785
#define ORD_WIN32MAKERECT                786
#define ORD_WIN32MAPDLGPOINTS            787
#define ORD_WIN32MAPWINDOWPOINTS         788
#define ORD_WIN32MESSAGEBOX              789
#define ORD_WIN32MSGSEMWAIT              790
#define ORD_WIN32NEXTCHAR                791
#define ORD_WIN32OFFSETRECT              792
#define ORD_WIN32OPENCLIPBRD             793
#define ORD_WIN32OPENWINDOWDC            794
#define ORD_WIN32PREVCHAR                795
#define ORD_WIN32PROCESSDLG              796
#define ORD_WIN32PTINRECT                797
#define ORD_WIN32QUERYACCELTABLE         798
#define ORD_WIN32QUERYACTIVEWINDOW       799
#define ORD_WIN32QUERYANCHORBLOCK        800
#define ORD_WIN32QUERYATOMLENGTH         801
#define ORD_WIN32QUERYATOMNAME           802
#define ORD_WIN32QUERYATOMUSAGE          803
#define ORD_WIN32QUERYCAPTURE            804
#define ORD_WIN32QUERYCLASSNAME          805
#define ORD_WIN32QUERYCLIPBRDDATA        806
#define ORD_WIN32QUERYCLIPBRDFMTINFO     807
#define ORD_WIN32QUERYCLIPBRDOWNER       808
#define ORD_WIN32QUERYCLIPBRDVIEWER      809
#define ORD_WIN32QUERYCP                 810
#define ORD_WIN32QUERYCPLIST             811
#define ORD_WIN32QUERYCURSORINFO         812
#define ORD_WIN32QUERYDESKTOPWINDOW      813
#define ORD_WIN32QUERYDLGITEMSHORT       814
#define ORD_WIN32QUERYDLGITEMTEXT        815
#define ORD_WIN32QUERYDLGITEMTEXTLENGTH  816
#define ORD_WIN32QUERYFOCUS              817
#define ORD_WIN32QUERYMSGPOS             818
#define ORD_WIN32QUERYMSGTIME            819
#define ORD_WIN32QUERYOBJECTWINDOW       820
#define ORD_WIN32QUERYPOINTER            821
#define ORD_WIN32QUERYPOINTERINFO        822
#define ORD_WIN32QUERYPOINTERPOS         823
#define ORD_WIN32QUERYQUEUEINFO          824
#define ORD_WIN32QUERYQUEUESTATUS        825
#define ORD_WIN32QUERYSYSCOLOR           826
#define ORD_WIN32QUERYSYSMODALWINDOW     827
#define ORD_WIN32QUERYSYSPOINTER         828
#define ORD_WIN32QUERYSYSVALUE           829
#define ORD_WIN32QUERYSYSTEMATOMTABLE    830
#define ORD_WIN32QUERYUPDATERECT         831
#define ORD_WIN32QUERYUPDATEREGION       832
#define ORD_WIN32QUERYVERSION            833
#define ORD_WIN32QUERYWINDOW             834
#define ORD_WIN32QUERYWINDOWDC           835
#define ORD_WIN32QUERYWINDOWPOS          837
#define ORD_WIN32QUERYWINDOWPROCESS      838
#define ORD_WIN32QUERYWINDOWPTR          839
#define ORD_WIN32QUERYWINDOWRECT         840
#define ORD_WIN32QUERYWINDOWTEXT         841
#define ORD_WIN32QUERYWINDOWTEXTLENGTH   842
#define ORD_WIN32QUERYWINDOWULONG        843
#define ORD_WIN32QUERYWINDOWUSHORT       844
#define ORD_WIN32REGISTERUSERDATATYPE    845
#define ORD_WIN32REGISTERUSERMSG         846
#define ORD_WIN32RELEASEPS               848
#define ORD_WIN32SCROLLWINDOW            849
#define ORD_WIN32SETACCELTABLE           850
#define ORD_WIN32SETACTIVEWINDOW         851
#define ORD_WIN32SETCAPTURE              852
#define ORD_WIN32SETCLASSMSGINTEREST     853
#define ORD_WIN32SETCLIPBRDDATA          854
#define ORD_WIN32SETCLIPBRDOWNER         855
#define ORD_WIN32SETCLIPBRDVIEWER        856
#define ORD_WIN32SETCP                   857
#define ORD_WIN32SETDLGITEMSHORT         858
#define ORD_WIN32SETDLGITEMTEXT          859
#define ORD_WIN32SETFOCUS                860
#define ORD_WIN32SETMSGINTEREST          861
#define ORD_WIN32SETMSGMODE              862
#define ORD_WIN32SETMULTWINDOWPOS        863
#define ORD_WIN32SETOWNER                864
#define ORD_WIN32SETPARENT               865
#define ORD_WIN32SETPOINTER              866
#define ORD_WIN32SETPOINTERPOS           867
#define ORD_WIN32SETRECT                 868
#define ORD_WIN32SETRECTEMPTY            869
#define ORD_WIN32SETSYNCHROMODE          870
#define ORD_WIN32SETSYSCOLORS            871
#define ORD_WIN32SETSYSMODALWINDOW       872
#define ORD_WIN32SETSYSVALUE             873
#define ORD_WIN32SETWINDOWBITS           874
#define ORD_WIN32SETWINDOWPOS            875
#define ORD_WIN32SETWINDOWPTR            876
#define ORD_WIN32SETWINDOWTEXT           877
#define ORD_WIN32SETWINDOWULONG          878
#define ORD_WIN32SETWINDOWUSHORT         879
#define ORD_WIN32SHOWCURSOR              880
#define ORD_WIN32SHOWPOINTER             881
#define ORD_WIN32SHOWTRACKRECT           882
#define ORD_WIN32SHOWWINDOW              883
#define ORD_WIN32STARTTIMER              884
#define ORD_WIN32STOPTIMER               885
#define ORD_WIN32SUBSTITUTESTRINGS       886
#define ORD_WIN32SUBTRACTRECT            887
#define ORD_WIN32TERMINATE               888
#define ORD_WIN32TRACKRECT               890
#define ORD_WIN32UNIONRECT               891
#define ORD_WIN32UPDATEWINDOW            892
#define ORD_WIN32UPPER                   893
#define ORD_WIN32UPPERCHAR               894
#define ORD_WIN32VALIDATERECT            895
#define ORD_WIN32VALIDATEREGION          896
#define ORD_WIN32WAITMSG                 897
#define ORD_WIN32WINDOWFROMDC            898
#define ORD_WIN32WINDOWFROMID            899
#define ORD_WIN32WINDOWFROMPOINT         900
#define ORD_WIN32BROADCASTMSG            901
#define ORD_WIN32POSTQUEUEMSG            902
#define ORD_WIN32SENDDLGITEMMSG          903
#define ORD_WIN32TRANSLATEACCEL          904
#define ORD_WIN32CALLMSGFILTER           905
#define ORD_WIN32CREATEFRAMECONTROLS     906
#define ORD_WIN32CREATEMENU              907
#define ORD_WIN32CREATESTDWINDOW         908
#define ORD_WIN32CREATEWINDOW            909
#define ORD_WIN32DEFDLGPROC              910
#define ORD_WIN32DEFWINDOWPROC           911
#define ORD_WIN32DISPATCHMSG             912
#define ORD_WIN32DRAWTEXT                913
#define ORD_WIN32GETDLGMSG               914
#define ORD_WIN32GETMSG                  915
#define ORD_WIN32MSGMUXSEMWAIT           916
#define ORD_WIN32MULTWINDOWFROMIDS       917
#define ORD_WIN32PEEKMSG                 918
#define ORD_WIN32POSTMSG                 919
#define ORD_WIN32SENDMSG                 920
#define ORD_WIN32SETKEYBOARDSTATETABLE   921
#define ORD_WIN32CREATEDLG               922
#define ORD_WIN32DLGBOX                  923
#define ORD_WIN32LOADDLG                 924
#define ORD_WIN32QUERYCLASSINFO          925
#define ORD_WIN32REGISTERCLASS           926
#define ORD_WIN32RELEASEHOOK             927
#define ORD_WIN32SETHOOK                 928
#define ORD_WIN32SUBCLASSWINDOW          929
#define ORD_WIN32SETCLASSTHUNKPROC       930
#define ORD_WIN32QUERYCLASSTHUNKPROC     931
#define ORD_WIN32SETWINDOWTHUNKPROC      932
#define ORD_WIN32QUERYWINDOWTHUNKPROC    933
#define ORD_WIN32QUERYWINDOWMODEL        934
#define ORD_WIN32SETDESKTOPBKGND         935
#define ORD_WIN32QUERYDESKTOPBKGND       936
#define ORD_WIN32POPUPMENU               937
#define ORD_WIN32SETPRESPARAM            938
#define ORD_WIN32QUERYPRESPARAM          939
#define ORD_WIN32REMOVEPRESPARAM         940
#define ORD_WIN32REALIZEPALETTE          941
#define ORD_WIN32CREATEPOINTERINDIRECT   942
#define ORD_WIN32SAVEWINDOWPOS           943
#define ORD_WIN32GETERASEPS              952
#define ORD_WIN32RELEASEERASEPS          953
#define ORD_WIN32SETPOINTEROWNER         971
#define ORD_WIN32STRETCHPOINTER          968
#define ORD_WIN32SETERRORINFO            977
#define ORD_WIN32WAITEVENTSEM            978
#define ORD_WIN32REQUESTMUTEXSEM         979
#define ORD_WIN32WAITMUXWAITSEM          980
/* PMPIC */
#define ORD_PICPRINT            1
#define ORD_PICICHG             2
#define ORD_PIC32PRINT          11
#define ORD_PIC32ICHG           12
#define ORD_PRF32PIF2MET        13
/* PMSHAPI */
#define ORD_WINQUERYPROFILEINT            2
#define ORD_WINQUERYPROFILESTRING         3
#define ORD_WINWRITEPROFILESTRING         4
#define ORD_WINQUERYPROFILESIZE           5
#define ORD_WINQUERYPROFILEDATA           6
#define ORD_WINWRITEPROFILEDATA           7
#define ORD_WININITSESSIONMGR             8
#define ORD_WINSETFGNDWINDOW              9
#define ORD_WINADDPROGRAM                 12
#define ORD_WINREMOVEPROGRAM              13
#define ORD_WINCHANGEPROGRAM              14
#define ORD_WINQUERYDEFINITION            15
#define ORD_WINQUERYPROGRAMTITLES         16
#define ORD_WINCREATEGROUP                17
#define ORD_WINADDTOGROUP                 19
#define ORD_WINQUERYPROGRAMUSE            20
#define ORD_WINREMOVEFROMGROUP            21
#define ORD_WINDESTROYGROUP               23
#define ORD_WINQUERYFILEEXTOPTS           24
#define ORD_WINSETFILEEXTOPTS             25
#define ORD_WINQUERYPROGRAMTYPE           26
#define ORD_PRFQUERYPROFILEINT            32
#define ORD_PRFQUERYPROFILESTRING         33
#define ORD_PRFWRITEPROFILESTRING         34
#define ORD_PRFQUERYPROFILESIZE           35
#define ORD_PRFQUERYPROFILEDATA           36
#define ORD_PRFWRITEPROFILEDATA           37
#define ORD_PRFOPENPROFILE                38
#define ORD_PRFCLOSEPROFILE               39
#define ORD_PRFRESET                      42
#define ORD_PRFQUERYPROFILE               43
#define ORD_WININSTSTARTAPP               44
#define ORD_WINTERMINATEAPP               45
#define ORD_WINCREATESWITCHENTRY          46
#define ORD_WINQUERYSESSIONTITLE          47
#define ORD_WINADDSWITCHENTRY             48
#define ORD_WINCHANGESWITCHENTRY          49
#define ORD_PRFADDPROGRAM                 50
#define ORD_PRFREMOVEPROGRAM              51
#define ORD_PRFCHANGEPROGRAM              52
#define ORD_PRFQUERYDEFINITION            53
#define ORD_PRFQUERYPROGRAMTITLES         54
#define ORD_PRFCREATEGROUP                55
#define ORD_WINQUERYSWITCHENTRY           56
#define ORD_WINQUERYSWITCHHANDLE          57
#define ORD_PRFQUERYPROGRAMHANDLE         58
#define ORD_PRFQUERYPROGRAMCATEGORY       59
#define ORD_PRFDESTROYGROUP               60
#define ORD_WINQUERYTASKTITLE             65
#define ORD_WINQUERYTASKSIZEPOS           66
#define ORD_WINQUERYSWITCHLIST            67
#define ORD_WINREMOVESWITCHENTRY          68
#define ORD_WINSWITCHTOPROGRAM            69
#define ORD_WINSWITCHPROGRAMREGISTER      70
#define ORD_WINENDPROGRAM                 73
#define ORD_WINSTOPPROGRAM                74
#define ORD_WINENDWINDOWSESSION           75
#define ORD_WINSWITCHTOTASKMANAGER        78
#define ORD_WINSWITCHTOPROGRAM2           80
#define ORD_WINPROCESSHOTKEY              81
#define ORD_WININITSESSION                82
#define ORD_WINENDSESSION                 83
#define ORD_WININITSWENTRY                84
#define ORD_WINSETSWENTRY                 85
#define ORD_WINQUERYEXTIDFOCUS            86
#define ORD_WINSETEXTIDFOCUS              87
#define ORD_WINNOSHUTDOWN                 91
#define ORD_WINSETTITLE                   93
#define ORD_WINSETTITLEANDICON            97
#define ORD_PRF32QUERYPROFILESIZE         101
#define ORD_PRF32OPENPROFILE              102
#define ORD_PRF32CLOSEPROFILE             103
#define ORD_PRF32REMOVEPROGRAM            104
#define ORD_PRF32DESTROYGROUP             106
#define ORD_PRF32QUERYPROFILE             107
#define ORD_PRF32RESET                    108
#define ORD_PRF32ADDPROGRAM               109
#define ORD_PRF32CHANGEPROGRAM            110
#define ORD_PRF32QUERYDEFINITION          111
#define ORD_PRF32QUERYPROGRAMTITLES       113
#define ORD_PRF32QUERYPROFILEINT          114
#define ORD_PRF32QUERYPROFILESTRING       115
#define ORD_PRF32WRITEPROFILESTRING       116
#define ORD_PRF32QUERYPROFILEDATA         117
#define ORD_PRF32WRITEPROFILEDATA         118
#define ORD_WIN32STARTAPP                 119
#define ORD_WIN32ADDSWITCHENTRY           120
#define ORD_WIN32CREATESWITCHENTRY        121
#define ORD_WIN32QUERYSESSIONTITLE        122
#define ORD_WIN32CHANGESWITCHENTRY        123
#define ORD_WIN32QUERYSWITCHENTRY         124
#define ORD_WIN32QUERYSWITCHHANDLE        125
#define ORD_WIN32QUERYSWITCHLIST          126
#define ORD_WIN32QUERYTASKSIZEPOS         127
#define ORD_WIN32QUERYTASKTITLE           128
#define ORD_WIN32REMOVESWITCHENTRY        129
#define ORD_WIN32TERMINATEAPP             130
#define ORD_WIN32SWITCHTOPROGRAM          131
#define ORD_WIN32SWITCHPROGRAMREGISTER    156
#define ORD_WINSTARTAPP                   201
#define ORD_WINHAPPFROMPID                208
#define ORD_WINHSWITCHFROMHAPP            209
/* QUECALLS */
#define ORD_DOSREADQUEUE      1
#define ORD_DOSPURGEQUEUE     2
#define ORD_DOSCLOSEQUEUE     3
#define ORD_DOSQUERYQUEUE     4
#define ORD_DOSPEEKQUEUE      5
#define ORD_DOSWRITEQUEUE     6
#define ORD_DOSOPENQUEUE      7
#define ORD_DOSCREATEQUEUE    8
#define ORD_DOS32READQUEUE    9
#define ORD_DOS32PURGEQUEUE  10
#define ORD_DOS32CLOSEQUEUE  11
#define ORD_DOS32QUERYQUEUE  12
#define ORD_DOS32PEEKQUEUE   13
#define ORD_DOS32WRITEQUEUE  14
#define ORD_DOS32OPENQUEUE   15
#define ORD_DOS32CREATEQUEUE 16
/* SESMGR */
#define ORD_DOSSTOPSESSION           8
#define ORD_DOSSELECTSESSION         9
#define ORD_DOSSETSESSION           14
#define ORD_DOSSTARTSESSION         17
#define ORD_DOSSMREGISTERDD         29
#define ORD_DOS32STARTSESSION       37
#define ORD_DOS32SELECTSESSION      38
#define ORD_DOS32SETSESSION         39
#define ORD_DOS32STOPSESSION        40
/* PMSTDDLG */
#define ORD_WINFONTDLG              2
#define ORD_WINDEFFONTDLGPROC       3
#define ORD_WINFILEDLG              4
#define ORD_WINDEFFILEDLGPROC       5
#define ORD_WINFREEFILEDLGLIST      6
/* VIOCALLS */
#define ORD_VIOENDPOPUP          1
#define ORD_VIOGETPHYSBUF        2
#define ORD_VIOGETANSI           3
#define ORD_VIOSETANSI           5
#define ORD_VIODEREGISTER        6
#define ORD_VIOSCROLLUP          7
#define ORD_VIOPRTSC             8
#define ORD_VIOGETCURPOS         9
#define ORD_VIOWRTCELLSTR        10
#define ORD_VIOPOPUP             11
#define ORD_VIOSCROLLRT          12
#define ORD_VIOWRTCHARSTR        13
#define ORD_VIOSETCURPOS         15
#define ORD_VIOSCRUNLOCK         18
#define ORD_VIOWRTTTY            19
#define ORD_VIOGETMODE           21
#define ORD_VIOSETMODE           22
#define ORD_VIOSCRLOCK           23
#define ORD_VIOREADCELLSTR       24
#define ORD_VIOSAVREDRAWWAIT     25
#define ORD_VIOWRTNATTR          26
#define ORD_VIOGETCURTYPE        27
#define ORD_VIOSAVREDRAWUNDO     28
#define ORD_VIOGETFONT           29
#define ORD_VIOREADCHARSTR       30
#define ORD_VIOGETBUF            31
#define ORD_VIOSETCURTYPE        32
#define ORD_VIOSETFONT           33
#define ORD_VIOMODEUNDO          35
#define ORD_VIOMODEWAIT          37
#define ORD_VIOGETCP             40
#define ORD_VIOSETCP             42
#define ORD_VIOSHOWBUF           43
#define ORD_VIOSCROLLLF          44
#define ORD_VIOREGISTER          45
#define ORD_VIOGETCONFIG         46
#define ORD_VIOSCROLLDN          47
#define ORD_VIOWRTCHARSTRATT     48
#define ORD_VIOGETSTATE          49
#define ORD_VIOPRTSCTOGGLE       50
#define ORD_VIOSETSTATE          51
#define ORD_VIOWRTNCELL          52
#define ORD_VIOWRTNCHAR          53
#define ORD_VIOASSOCIATE         55
#define ORD_VIOCREATEPS          56
#define ORD_VIODELETESETID       57
#define ORD_VIOGETDEVICECELLSIZE 58
#define ORD_VIOGETORG            59
#define ORD_VIOCREATELOGFONT     60
#define ORD_VIODESTROYPS         61
#define ORD_VIOQUERYSETIDS       62
#define ORD_VIOSETORG            63
#define ORD_VIOQUERYFONTS        64
#define ORD_VIOSETDEVICECELLSIZE 65
#define ORD_VIOSHOWPS            66
#define ORD_VIOGETPSADDRESS      67
#define ORD_VIOGLOBALREG         70
#define ORD_XVIOSETCASTATE       71
#define ORD_XVIOCHECKCHARTYPE    72
#define ORD_XVIODESTROYCA        73
#define ORD_XVIOCREATECA         74
#define ORD_VIOCHECKCHARTYPE     75
#define ORD_XVIOGETCASTATE       76
/* PMVIOP */
#define ORD_WINDEFAVIOWINDOWPROC        30

#ifdef __IBMC__
#pragma checkout( suspend )
   #ifndef __CHKHDR__
      #pragma checkout( resume )
   #endif
#pragma checkout( resume )
#endif

#endif /* __BSEORD__ */
